﻿using CefBridgeDataExchange.Tests.CefRelated;
using CefBridgeDataExchange.Tests.Services;
using CefSharp;
using CefSharp.WinForms;
using System.Windows.Forms;

namespace CefBridgeDataExchange.Tests
{
    public partial class DemoForm : Form
    {
        private readonly DataExchangeDispatcherBuilder _dataExchange;
        private ChromiumWebBrowser _browser;

        public DemoForm()
        {
            InitializeComponent();
            _dataExchange = new DataExchangeDispatcherBuilder();
            _dataExchange.RegisterService<IWindowControlService>(new WindowControlService(this));
        }

        private void DemoForm_Shown(object sender, System.EventArgs e)
        {
            CreateCefBrowserControl();
        }

        private void CreateCefBrowserControl()
        {
            if (null != _browser)
            {
                MainPanel.Controls.Remove(_browser);
                _browser.Dispose();
            }

            _browser = new ChromiumWebBrowser(CefInit.ResourceRootUrl + "index.html");

            _dataExchange.RegisterService<ICefDevService>(new CefDevService(_browser), true);

            _browser.RegisterJsObject(nameof(CefBridgeDataExchange), _dataExchange.Dispatcher, new BindingOptions { CamelCaseJavascriptNames = false });

            _browser.Dock = DockStyle.Fill;
            MainPanel.Controls.Add(_browser);
            _browser.BringToFront();
        }

        private void F12ToolStripButton_Click(object sender, System.EventArgs e)
        {
            _browser.ShowDevTools();
        }
    }
}
